# Current Platform Incentives spec

<!--
valid status values are: Pre-draft|Draft|Proposal|Accepted
-->
* Authors: Will Ruddick <willruddick@gmail.com> (grassecon.org)
* Date: 2020.04.22
* Version: 1
* Status: Pre-draft

## Rationale
The current Sarafu system seeks to maximize circulation in order to fill market gaps and help CIC users to support eachother.

## Currently - bonding CIC issuance to a reserve with no market value.
Grassroots Economics created a pool of 16 Million Sarafu tokens (which they value 1:1 with Kenyan Shillings ala buy-backs - see below). 
The following are all rules are platform (statemachine) based (not blockchain contract based). Note that these rules are for the Sarafu CIC only and are not meant to be the rules for other CIC creators.
1. Outgoing Sarafu
   1. **airdrop-full-profile**: New users that have traded outward and fill out their profiles (name, business, location, gender) get 50 Sarafu (a CIC)  (Shown as Disbursement in database)
   1. **referral**: Users that are the 1st to send a new user get 50 Sarafu - after that new user has begun to trade with another user (not the referrer) (Shown as Disbursement in database)
   1. **usage reward**: Users get a daily or weekly Sarafu bonues depending on how they trade. They are ranked by trade centrality and clustering and awarded based on their percentage of such overall trade. (Possibly adding k-cycle centrality).(Shown as Disbursement in database (transaction meta-data))
   1. **donation bonues** Anyone with Mpesa or Bonga points (National Currency eMoney) can send them to Grassroots Economics to receive additional Sarafu (Shown as Disbursement in database) these funds are used for community support, Sarafu buy-backs and operations
1. Incomming Sarafu 
   1.  **holding fee**: Users get a weekly deduction of 0.5% of their Sarafu balance - which is added to the reward pool. If an account is dormant (no trades in or out) for 7 days 20 Sarafu are deducted and added back to the reward pool. (Shown as Reclaimation in database). The total disbursment or reclamation is a combination of the usage reward and holding fee.
   1. **redemption**: Selected vendors can redeem a donor designated amount of Sarafu balance for Kenyan Shillings  using eMoney (Mpesa).
   1. **minting/creating**: Currently the Sarafu supply is bonded to a virtual reserve token with no market value so there are no restrictions on the supply of Sarafu

## After - bonding to a reserve is market value.
After the migration to xCHF as reserve 
anyone (with access to blockchain) in the world can contribute reserve in the form of xCHF. xCHF is a stable token to the US dollar and can be purchased with USD. 
With a reserve in xCHF each Sarafu token will now have spot price or excahnge price to xCHF given by P = R/(S*TRR)
Where R = the amount of xCHF in reserve, S= the total supply of Sarafu, and TRR = Target Reserve Ratio = that ratio of R/S such that the echange price is 1:1.
1. **Off chain incentives** - Grassroots Economics will continue with all the above incentives for the Sarafu token
1. **Adding Reserve via bonding curve** - Anyone with access to the blockchain (via a webApp or MetaMask) can add xCHF and mint more Sarafu (+) increase the value of all Sarafu
  1. As the reserve of Sarafu is depleted and the exchange price drops Grassroots Economics as well as other donors will add more reserve and mint more tokens to distribute.
1. **Liquidating CICs** - Anyone with access to the blockchain (via a webApp or MetaMask) can add send Sarafu to the converter contract to destroy it and withdraw reserve (-) decreasing the value of all Sarafu.
  1. **Usage of on-chain reserves** - Grassroots Economics will liquidate Sarafu it collects to pull out excess reserve and convert it (xCHF) to Kenyan shillings to continue with Savings Group buy backs.
1. **Conversion fee** - A % fee on conversion between reserve and supply in both directions (minting or liquidating tokens) is done on blockchain and added to the reserve.


## Implementation

### Workflow

### Variables

### Interface


## Testing
<!--
Please describe what test vectors that are required for this implementation
-->

## Changelog
<!--
Please remember to describe every change to this document in the changelog using 
serial number:

* version 1:
-->
